unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Spin;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button1: TButton;
    GroupBox1: TGroupBox;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  pokreti: array[1..8,1..2] of integer = ((1,2), (1,-2), (-1,2), (-1,-2),
                                     (2,1), (2,-1), (-2,1), (-2,-1));

implementation

{$R *.dfm}


//funkcija proverava da li je skok moguc
function MozeDaSkoci(kolona, vrsta: integer): boolean;
begin
Result:= false;
if (kolona>0) and (kolona<9) and (vrsta>0) and (vrsta<9) then
  Result:= true;
end;



//funkcija koja pronalazi moguce skokove
procedure Skoci(kolona, vrsta: integer);
var i, novaKolona, novaVrsta: integer;
begin
Form1.StringGrid1.Cells[kolona-1, vrsta-1]:= 'Start';

for i:= 1 to 8 do
  begin
  novaKolona:= kolona + pokreti[i, 1];
  novaVrsta:= vrsta + pokreti[i, 2];
  if MozeDaSkoci(novaKolona, novaVrsta) then
    Form1.StringGrid1.Cells[novaKolona-1, novaVrsta-1]:= 'Moze';
  end;
end;



//pronalazenje mogucih skokova na klik
procedure TForm1.Button1Click(Sender: TObject);
var i, j:  integer;
begin
for i:= 0 to 7 do
  for j:= 0 to 7 do
   StringGrid1.Cells[i, j]:= '';

Skoci(SpinEdit1.Value, SpinEdit2.Value);
end;



//zatvaranje aplikacije na klik
procedure TForm1.Button2Click(Sender: TObject);
begin
Application.Terminate;
end;



//iscrtavanje StringGrida
procedure TForm1.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var s: string;
begin
s:= StringGrid1.Cells[ACol, ARow];

if (ACol + ARow) mod 2 = 0 then
  StringGrid1.Canvas.Brush.Color:= clBlack
else
  StringGrid1.Canvas.Brush.Color:= clWhite;

StringGrid1.Canvas.FillRect(Rect);
StringGrid1.Canvas.TextOut(Rect.Left +10, Rect.Top + 17, s);
end;
end.
